package com.fp.persistence.pgeneral.batch;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEBATCH*/
@Entity(name="TgeneBatch")
@Table(name="TGENEBATCH")
public class TgeneBatch extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneBatch
*/
@EmbeddedId
private TgeneBatchKey pk;
@Column(name="ACTIVE", nullable=true)

/**
* Y se ejecuta la regla al ejecutar el fin de dia,  N no se ejecuta la regla al ejecutar el fin de dia.
*/
private String active;

@Column(name="PROCESSORDER", nullable=true)

/**
* Orden de ejecucion de modulo
*/
private Integer processorder;

@Column(name="THREADS", nullable=true)

/**
* Numero de hilos a levantar por modulo.
*/
private Integer threads;

/**Contructor por defecto*/
public TgeneBatch(){
}
/**Contructor de TgeneBatch
@param pPk Clave Primaria del entity
*/
public TgeneBatch(TgeneBatchKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneBatch
*/
public static TgeneBatch find(EntityManager pEntityManager,TgeneBatchKey pKey) throws Exception{
    TgeneBatch obj = pEntityManager.find(TgeneBatch.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneBatch
@return El objeto que referencia a la Clave primaria de TgeneBatch
*/
public TgeneBatchKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneBatch
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneBatch
*/
public void setPk(TgeneBatchKey pPk){
  pk=pPk;
}
/**Obtiene el valor de active
@return valor de active*/
public String getActive(){
  return active;
}
/**Fija el valor de active
@param pActive nuevo Valor de active*/
public void setActive(String pActive){
  active=pActive;
}

/**Obtiene el valor de processorder
@return valor de processorder*/
public Integer getProcessorder(){
  return processorder;
}
/**Fija el valor de processorder
@param pProcessorder nuevo Valor de processorder*/
public void setProcessorder(Integer pProcessorder){
  processorder=pProcessorder;
}

/**Obtiene el valor de threads
@return valor de threads*/
public Integer getThreads(){
  return threads;
}
/**Fija el valor de threads
@param pThreads nuevo Valor de threads*/
public void setThreads(Integer pThreads){
  threads=pThreads;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneBatch))return false;
    TgeneBatch that = (TgeneBatch) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneBatch
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneBatch
*/
public Object createInstance(){
 TgeneBatch instance=new TgeneBatch();	
 instance.setPk(new TgeneBatchKey());
 return instance;
}
/**Clona la entidad TgeneBatch
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneBatch p=(TgeneBatch)this.clone();
  p.setPk((TgeneBatchKey)this.pk.cloneMe());
  return p;
}
}
